// CDUCCCircuit.cpp :  Microsoft Visual C++  ActiveX ؼװĶ


#include "stdafx.h"
#include "CDUCCCircuit.h"
 
// Dispatch interfaces referenced by this interface
#include "xdpage.h"
#include "xdwindow.h"
#include "xdshape.h"
#include "xdgroupshape.h"
#include "xdlinkshape.h"
#include "xdportsshape.h"
#include "xdportshape.h"
#include "xdeformshape.h"

/////////////////////////////////////////////////////////////////////////////
// CDUCCCircuit

IMPLEMENT_DYNCREATE(CDUCCCircuit, CWnd)

/////////////////////////////////////////////////////////////////////////////
// CDUCCCircuit properties

long CDUCCCircuit::GetCanvasWidth()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void CDUCCCircuit::SetCanvasWidth(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

long CDUCCCircuit::GetCanvasHeight()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void CDUCCCircuit::SetCanvasHeight(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

LPDISPATCH CDUCCCircuit::GetParent()
{
	LPDISPATCH result;
	GetProperty(0x7be, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCCircuit::SetParent(LPDISPATCH propVal)
{
	SetProperty(0x7be, VT_DISPATCH, propVal);
}

LPDISPATCH CDUCCCircuit::GetRoot()
{
	LPDISPATCH result;
	GetProperty(0x7bd, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCCircuit::SetRoot(LPDISPATCH propVal)
{
	SetProperty(0x7bd, VT_DISPATCH, propVal);
}

CXDPage CDUCCCircuit::GetActivePage()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bb, VT_DISPATCH, (void*)&pDispatch);
	return CXDPage(pDispatch);
}

void CDUCCCircuit::SetActivePage(LPDISPATCH propVal)
{
	SetProperty(0x7bb, VT_DISPATCH, propVal);
}

CXDWindow CDUCCCircuit::GetActiveWindow()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bc, VT_DISPATCH, (void*)&pDispatch);
	return CXDWindow(pDispatch);
}

void CDUCCCircuit::SetActiveWindow(LPDISPATCH propVal)
{
	SetProperty(0x7bc, VT_DISPATCH, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// CDUCCCircuit operations

long CDUCCCircuit::AddRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCCircuit::AddTextShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszText)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszText);
	return result;
}

long CDUCCCircuit::AddEllipseShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCCircuit::AddRoundRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCCircuit::AddHyLinkShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

long CDUCCCircuit::AddBmpFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCCircuit::AddEmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCCircuit::AddWmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCCircuit::AddShapeByType(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

long CDUCCCircuit::AddCompositeShapeByFile(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCCircuit::AddCompositeShapeByID(short xLeft, short yTop, short xRight, short yBottom, short nResId, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, nResId, lpszCaption);
	return result;
}

long CDUCCCircuit::AddLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCCircuit::AddDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

BOOL CDUCCCircuit::Read(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x10, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

BOOL CDUCCCircuit::Write(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x11, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCCircuit::Export()
{
	InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Undo()
{
	InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Redo()
{
	InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Cut()
{
	InvokeHelper(0x15, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Copy()
{
	InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Paste()
{
	InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::Clear()
{
	InvokeHelper(0x18, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ClearAll()
{
	InvokeHelper(0x19, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::SelectAll()
{
	InvokeHelper(0x1a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::GetShowGrid()
{
	BOOL result;
	InvokeHelper(0x1b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetShowGrid(BOOL bGrid)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGrid);
}

void CDUCCCircuit::OnGridProp()
{
	InvokeHelper(0x1d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::GetDesignMode()
{
	BOOL result;
	InvokeHelper(0x1e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetDesignMode(BOOL bMode)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bMode);
}

BOOL CDUCCCircuit::GetSnapToGrid()
{
	BOOL result;
	InvokeHelper(0x20, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetSnapToGrid(BOOL bSnap)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bSnap);
}

BOOL CDUCCCircuit::GetGlueToHandle()
{
	BOOL result;
	InvokeHelper(0x22, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetGlueToHandle(BOOL bGlue)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGlue);
}

BOOL CDUCCCircuit::GetShowPageBreakLine()
{
	BOOL result;
	InvokeHelper(0x24, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetShowPageBreakLine(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x25, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

BOOL CDUCCCircuit::GetShowPort()
{
	BOOL result;
	InvokeHelper(0x26, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetShowPort(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x27, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

long CDUCCCircuit::GetZoomPercent()
{
	long result;
	InvokeHelper(0x28, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetZoomPercent(long nZoom)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x29, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nZoom);
}

void CDUCCCircuit::ZoomIn()
{
	InvokeHelper(0x2a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomOut()
{
	InvokeHelper(0x2b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomToFitPage()
{
	InvokeHelper(0x2c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomToFitPageHeight()
{
	InvokeHelper(0x2d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomToFitPageWidth()
{
	InvokeHelper(0x2e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomToFitSelect()
{
	InvokeHelper(0x2f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ZoomToRect(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x30, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCCircuit::ZoomToSelection()
{
	InvokeHelper(0x31, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoZoomWithinRect()
{
	InvokeHelper(0x32, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowPagePropDlg()
{
	InvokeHelper(0x33, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowHeaderAndFooterDlg()
{
	InvokeHelper(0x34, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowTextDlg()
{
	InvokeHelper(0x35, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowBulletsDlg()
{
	InvokeHelper(0x36, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowLineDlg()
{
	InvokeHelper(0x37, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowFillDlg()
{
	InvokeHelper(0x38, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowShadowDlg()
{
	InvokeHelper(0x39, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowEventDlg()
{
	InvokeHelper(0x3a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowCustomDlg()
{
	InvokeHelper(0x3b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawSelect()
{
	InvokeHelper(0x3c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawLine()
{
	InvokeHelper(0x3d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawArrowLine()
{
	InvokeHelper(0x3e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawCrossLine()
{
	InvokeHelper(0x3f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawArrowBezierLine()
{
	InvokeHelper(0x40, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawDimLine()
{
	InvokeHelper(0x41, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawFreeLine()
{
	InvokeHelper(0x42, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawFreeCloseLine()
{
	InvokeHelper(0x43, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawPolyLine()
{
	InvokeHelper(0x44, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawPolygon()
{
	InvokeHelper(0x45, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawEllipse()
{
	InvokeHelper(0x46, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRectangle()
{
	InvokeHelper(0x47, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRoundRect()
{
	InvokeHelper(0x48, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawCloseBezier()
{
	InvokeHelper(0x49, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawBezierLine()
{
	InvokeHelper(0x4a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawStatic()
{
	InvokeHelper(0x4b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawButton()
{
	InvokeHelper(0x4c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDoDrawImage()
{
	InvokeHelper(0x4d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawPort()
{
	InvokeHelper(0x4e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DrawCustomRect(long nType)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x4f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCCircuit::DoDrawLinkNormal()
{
	InvokeHelper(0x50, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawLinkUpRight()
{
	InvokeHelper(0x51, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawCornerLink()
{
	InvokeHelper(0x52, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawBezierLink()
{
	InvokeHelper(0x53, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoRotate()
{
	InvokeHelper(0x54, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoRotateLeft()
{
	InvokeHelper(0x55, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoRotateRight()
{
	InvokeHelper(0x56, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoFlipHorz()
{
	InvokeHelper(0x57, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoFlipVert()
{
	InvokeHelper(0x58, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::RotateAngle(long nAngle)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x59, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nAngle);
}

long CDUCCCircuit::GetRotateShapeCount()
{
	long result;
	InvokeHelper(0x5a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::Group()
{
	InvokeHelper(0x5b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UnGroup()
{
	InvokeHelper(0x5c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::EnableUnGroup()
{
	BOOL result;
	InvokeHelper(0x5d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoAlignLeft()
{
	InvokeHelper(0x5e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignRight()
{
	InvokeHelper(0x5f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignTop()
{
	InvokeHelper(0x60, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignBottom()
{
	InvokeHelper(0x61, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignCenter()
{
	InvokeHelper(0x62, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignVcenter()
{
	InvokeHelper(0x63, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignInviewHor()
{
	InvokeHelper(0x64, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoAlignInviewVer()
{
	InvokeHelper(0x65, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSpaceAcross()
{
	InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSpaceDown()
{
	InvokeHelper(0x67, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSizeWidth()
{
	InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSizeHeight()
{
	InvokeHelper(0x69, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSizeAll()
{
	InvokeHelper(0x6a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoLockcomp()
{
	InvokeHelper(0x6b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoUnlockcomp()
{
	InvokeHelper(0x6c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoMoveForward()
{
	InvokeHelper(0x6d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoMoveBack()
{
	InvokeHelper(0x6e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoMoveBackward()
{
	InvokeHelper(0x6f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoCmdNudgeleft()
{
	InvokeHelper(0x70, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoCmdNudgeright()
{
	InvokeHelper(0x71, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoCmdNudgetop()
{
	InvokeHelper(0x72, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoCmdNudgebottom()
{
	InvokeHelper(0x73, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoCmdAutoPan()
{
	InvokeHelper(0x74, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::GetTotalSelect()
{
	long result;
	InvokeHelper(0x75, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoEditSpot()
{
	InvokeHelper(0x76, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ClearSelectionHandles()
{
	InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::RestoreSelectionHandles()
{
	InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UpdateSelection()
{
	InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UpdateScrollSize()
{
	InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoTabOrder()
{
	InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::SetModifiedFlag(BOOL bFlag)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x7c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bFlag);
}

BOOL CDUCCCircuit::GetModifiedFlag()
{
	BOOL result;
	InvokeHelper(0x7d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::HitTest(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCCircuit::HitTestPort(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCCircuit::GetCompsCount()
{
	long result;
	InvokeHelper(0x80, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetPagePosition(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x81, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCCircuit::ChangePositionWithPages(long nHorzPages, long nVertPages)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x82, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nHorzPages, nVertPages);
}

void CDUCCCircuit::SetLockWithPages(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x83, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

unsigned long CDUCCCircuit::GetGridColor()
{
	unsigned long result;
	InvokeHelper(0x84, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetGridColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x85, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCCircuit::GetGridX()
{
	long result;
	InvokeHelper(0x86, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetGridX(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x87, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCCircuit::GetGridY()
{
	long result;
	InvokeHelper(0x88, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetGridY(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x89, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCCircuit::GetBkColor()
{
	long result;
	InvokeHelper(0x8a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCCircuit::GetPageBkColor()
{
	long result;
	InvokeHelper(0x8c, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetPageBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCCircuit::GetBrushType()
{
	long result;
	InvokeHelper(0x8e, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetBrushType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x8f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

long CDUCCCircuit::GetPatternColor()
{
	long result;
	InvokeHelper(0x90, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetPatternColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x91, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

BOOL CDUCCCircuit::IsFormMode()
{
	BOOL result;
	InvokeHelper(0x92, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetFormMode(BOOL bForm)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x93, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bForm);
}

long CDUCCCircuit::GetCommandState()
{
	long result;
	InvokeHelper(0x94, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::CanUndo()
{
	BOOL result;
	InvokeHelper(0x95, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::CanRedo()
{
	BOOL result;
	InvokeHelper(0x96, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::CanPaste()
{
	BOOL result;
	InvokeHelper(0x97, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetGridStyle()
{
	long result;
	InvokeHelper(0x98, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetGridLineType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x99, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCCircuit::DoPrintPreview(LPDISPATCH frm)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x9a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		frm);
}

void CDUCCCircuit::PrintDraw()
{
	InvokeHelper(0x9b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ChangeModelBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0x9c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCCircuit::ChangeModelStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x9d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCCircuit::ChangeModelIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCCircuit::ChangeModelUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCCircuit::ChangeModelFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xa0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCCircuit::ChangeModelDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xa1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCCircuit::ChangeModelDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xa2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCCircuit::ChangeModelColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xa3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCCircuit::ChangeModelDWordProp(long dwValue, short nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0xa4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeBoolProp(long shape, BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL VTS_I4;
	InvokeHelper(0xa5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeStringProp(long shape, LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR VTS_I4;
	InvokeHelper(0xa6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, strValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeIntProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeUINTProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeFloatProp(long shape, float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R4 VTS_I4;
	InvokeHelper(0xa9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, fValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeDoubleProp(long shape, double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_I4;
	InvokeHelper(0xaa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeDateTimeProp(long shape, DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_DATE VTS_I4;
	InvokeHelper(0xab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dtValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeColorProp(long shape, long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xac, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, crValue, nPropID);
}

void CDUCCCircuit::ChangeSingleShapeDWordProp(long shape, long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0xae, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0xaf, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xb2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xb3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xb4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCCircuit::ChangeSelectionDWordProp(long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCCircuit::AddUserData(long shape, long dwData)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwData);
}

long CDUCCCircuit::GetUserData(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xb8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::MoveShape(long shape, long nxOffset, long nyOffset)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xb9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nxOffset, nyOffset);
}

void CDUCCCircuit::ResizeShape(long shape, double dScaleX, double dScaleY, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8;
	InvokeHelper(0xba, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dScaleX, dScaleY, dOX, dOY);
}

void CDUCCCircuit::RotateShape(long shape, long nAngle, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0xbb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nAngle, dOX, dOY);
}

void CDUCCCircuit::PositionShape(long shape, long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xbc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xLeft, yTop, xRight, yBottom);
}

long CDUCCCircuit::GetCurrentSelectShape()
{
	long result;
	InvokeHelper(0xbd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::FindShapeByCaption(LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszCaption);
	return result;
}

long CDUCCCircuit::FindShapeByName(LPCTSTR lpszName)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszName);
	return result;
}

void CDUCCCircuit::DoPageSetup()
{
	InvokeHelper(0xc0, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsEditSpots()
{
	BOOL result;
	InvokeHelper(0xc1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShowCompsSelectDlg()
{
	InvokeHelper(0xc2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::GetTotalGroupShapes()
{
	long result;
	InvokeHelper(0xc3, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoMoveFront()
{
	InvokeHelper(0xc4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsTabOrder()
{
	BOOL result;
	InvokeHelper(0xc5, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetDrawType()
{
	long result;
	InvokeHelper(0xc6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoDrawCustomShapeID(long nResId)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nResId);
}

void CDUCCCircuit::DoDrawCustomShapeFile(LPCTSTR lpszResFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszResFile);
}

void CDUCCCircuit::UpdateAllShapes()
{
	InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UpdateCanvas()
{
	InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawTable()
{
	InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawArcLine()
{
	InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawPie()
{
	InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowPanWnd()
{
	InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsPanWndShow()
{
	BOOL result;
	InvokeHelper(0xcf, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableDisappearHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsEnablePickNearest()
{
	BOOL result;
	InvokeHelper(0xd1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnablePickNearest(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsAngleSnapEnabled()
{
	BOOL result;
	InvokeHelper(0xd3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableAngleSnap(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCCircuit::SetSnapAngle(long nWink)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nWink);
}

long CDUCCCircuit::GetSnapAngle()
{
	long result;
	InvokeHelper(0xd6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetPrimarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCCircuit::SetSecondarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCCircuit::AddShapePort(double dScaleX, double dScaleY)
{
	static BYTE parms[] =
		VTS_R8 VTS_R8;
	InvokeHelper(0xd9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dScaleX, dScaleY);
}

void CDUCCCircuit::DoDrawMultiSelect()
{
	InvokeHelper(0xda, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::AddArcLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xdb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCCircuit::AddTabShape(long nLeft, long nTop, long nRight, long nBottom, long nRows, long nCols, BOOL bFixRows, BOOL bFixCols, BOOL bShowGridLine)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL;
	InvokeHelper(0xdc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nLeft, nTop, nRight, nBottom, nRows, nCols, bFixRows, bFixCols, bShowGridLine);
	return result;
}

BOOL CDUCCCircuit::IsMultiSelectMode()
{
	BOOL result;
	InvokeHelper(0xdd, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::AddPieShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xde, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCCircuit::AddEllipseChordShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xdf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCCircuit::AddArcLine2Shape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd, bArrow);
	return result;
}

void CDUCCCircuit::SetHlpLineVisible(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xe1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCCircuit::DoDrawArcLine2()
{
	InvokeHelper(0xe2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawEllipseChord()
{
	InvokeHelper(0xe3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoMirrorFree()
{
	InvokeHelper(0xe4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoRemoveHlpLine()
{
	InvokeHelper(0xe5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoShowPosAndSizeDlg()
{
	InvokeHelper(0xe6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ExportAsBitmapFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

void CDUCCCircuit::ExportAsEMFFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

long CDUCCCircuit::AddExtLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCCircuit::AddHorzDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xea, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCCircuit::AddVertDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xeb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCCircuit::AddRadiusDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xec, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCCircuit::AddCaptionShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xed, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight, bArrow);
	return result;
}

long CDUCCCircuit::AddRectCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCCircuit::AddRoundCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xef, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCCircuit::AddCloudCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xf0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

BOOL CDUCCCircuit::IsHlpLineVisible()
{
	BOOL result;
	InvokeHelper(0xf1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsEnableSnapToHelpLine()
{
	BOOL result;
	InvokeHelper(0xf2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableSnapToHelpLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsEnableSnapToControlHandle()
{
	BOOL result;
	InvokeHelper(0xf4, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableSnapToControlHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsEnableSnapToSpot()
{
	BOOL result;
	InvokeHelper(0xf6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableSnapToSpot(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsEnableSnapToIntersectPoint()
{
	BOOL result;
	InvokeHelper(0xf8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableSnapToIntersectPoint(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsCenterDrawAllowed()
{
	BOOL result;
	InvokeHelper(0xfa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableCenterDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xfb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCCircuit::DoDrawCaptionline()
{
	InvokeHelper(0xfc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRectCallout()
{
	InvokeHelper(0xfd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRoundCallout()
{
	InvokeHelper(0xfe, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawCloudCallout()
{
	InvokeHelper(0xff, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawHorzDimline()
{
	InvokeHelper(0x100, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawVertDimline()
{
	InvokeHelper(0x101, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRadiusDimline()
{
	InvokeHelper(0x102, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawExtLine()
{
	InvokeHelper(0x103, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoReverseOrder()
{
	InvokeHelper(0x104, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoInfrontShape()
{
	InvokeHelper(0x105, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoBehindShape()
{
	InvokeHelper(0x106, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsRulerVisible()
{
	BOOL result;
	InvokeHelper(0x107, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::ShowRulers(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x108, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCCircuit::SetRulerUnit(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x109, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCCircuit::DoPutShapeToBack()
{
	InvokeHelper(0x10a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoFoPolyInsertpoint()
{
	InvokeHelper(0x10b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowInsertPoint()
{
	BOOL result;
	InvokeHelper(0x10c, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoFoPolyDeletepoint()
{
	InvokeHelper(0x10d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowDeletePoint()
{
	BOOL result;
	InvokeHelper(0x10e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoConvertSegmentToline()
{
	InvokeHelper(0x10f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowConvertSegmentToLine()
{
	BOOL result;
	InvokeHelper(0x110, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoConvertSegmentToCurve()
{
	InvokeHelper(0x111, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowConvertSegmentToCurve()
{
	BOOL result;
	InvokeHelper(0x112, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoRipUpPoint()
{
	InvokeHelper(0x113, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowRipUpPoint()
{
	BOOL result;
	InvokeHelper(0x114, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoDrawTurnCornerLinkLine()
{
	InvokeHelper(0x115, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawBreakCenterLinkLine()
{
	InvokeHelper(0x116, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoEllipseSelect()
{
	InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoConvertToPath()
{
	InvokeHelper(0x118, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowConvertToPath()
{
	BOOL result;
	InvokeHelper(0x119, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoConvertToPoly()
{
	InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowConvertToPoly()
{
	BOOL result;
	InvokeHelper(0x11b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShapesCombine()
{
	InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShapeCombine()
{
	BOOL result;
	InvokeHelper(0x11d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShapesDismantle()
{
	InvokeHelper(0x11e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShapeDismantle()
{
	BOOL result;
	InvokeHelper(0x11f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShapesMergeMerge()
{
	InvokeHelper(0x120, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShapeMergeMerge()
{
	BOOL result;
	InvokeHelper(0x121, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShapesMergeSubstract()
{
	InvokeHelper(0x122, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShapeMergeSubstract()
{
	BOOL result;
	InvokeHelper(0x123, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShapesMergeIntersect()
{
	InvokeHelper(0x124, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShapeMergeIntersect()
{
	BOOL result;
	InvokeHelper(0x125, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoConnectLines()
{
	InvokeHelper(0x126, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowConnectLines()
{
	BOOL result;
	InvokeHelper(0x127, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoBreakShapeToLines()
{
	InvokeHelper(0x128, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowBreakShapeToLines()
{
	BOOL result;
	InvokeHelper(0x129, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoCloseShape()
{
	InvokeHelper(0x12a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowCloseShape()
{
	BOOL result;
	InvokeHelper(0x12b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShearFree()
{
	InvokeHelper(0x12c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsAllowShearFree()
{
	BOOL result;
	InvokeHelper(0x12d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsEllipseSelectMode()
{
	BOOL result;
	InvokeHelper(0x12e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::ConnectSelectShapes()
{
	InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoGenCreateLink()
{
	InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::AddToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x131, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCCircuit::RemoveShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x132, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCCircuit::GetShapeBoolProp(long shape, long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x133, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID);
	return result;
}

CString CDUCCCircuit::GetShapeStringProp(long shape, long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x134, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCCircuit::GetShapeIntProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x135, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

short CDUCCCircuit::GetShapeUINTProp(long shape, long nPropID)
{
	short result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x136, DISPATCH_METHOD, VT_I2, (void*)&result, parms,
		shape, nPropID);
	return result;
}

float CDUCCCircuit::GetShapeFloatProp(long shape, long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x137, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

double CDUCCCircuit::GetShapeDoubleProp(long shape, long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x138, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		shape, nPropID);
	return result;
}

DATE CDUCCCircuit::GetShapeDateTimeProp(long shape, long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x139, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCCircuit::GetShapeColorProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCCircuit::GetShapeDwordProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCCircuit::ConnectTwoShapes(long shapefirst, long shapesecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapefirst, shapesecond);
	return result;
}

BOOL CDUCCCircuit::IsStaticShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsShapeLinked(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetBoundXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetBoundYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x140, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetBoundWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x141, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetBoundHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x142, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetSnapXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x143, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetSnapYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x144, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetSnapWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x145, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetSnapHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x146, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsPolyObject(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x147, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetInitRotateAngle(long shape, long angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x148, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCCircuit::UpdateComp(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x149, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCCircuit::IsShapeClosed(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14a, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetWithLabelShow(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

void CDUCCCircuit::SetWithLabelEditing(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

BOOL CDUCCCircuit::IsLinkShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsCompositeShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsGroupShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14f, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsKindShape(long shape, long Type)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x150, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, Type);
	return result;
}

long CDUCCCircuit::GetSelectionCount()
{
	long result;
	InvokeHelper(0x151, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetSelection(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x152, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCCircuit::GetShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x153, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCCircuit::GetCompositeShapeChildCount(long shapecomposite)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x154, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapecomposite);
	return result;
}

long CDUCCCircuit::GetCompositeShapeAt(long compositeshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x155, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compositeshape, index);
	return result;
}

long CDUCCCircuit::GetPortsShapePortCount(long portsshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x156, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape);
	return result;
}

long CDUCCCircuit::GetPortsShapePortShapeAt(long portsshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x157, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, index);
	return result;
}

long CDUCCCircuit::GetPortLinkCount(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x158, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCCircuit::GetPortLinkShapeAt(long portshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x159, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape, index);
	return result;
}

long CDUCCCircuit::GetLinkFromShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

long CDUCCCircuit::GetLinkToShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

void CDUCCCircuit::RemoveCurShapeToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCCircuit::IsShapeSelected(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::IsPortShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::AddDefaultPort(long portsshape, double xScale, double yScale)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x15f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, xScale, yScale);
	return result;
}

long CDUCCCircuit::ConnectWithTwoPorts(long portFirst, long portSecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x160, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portFirst, portSecond);
	return result;
}

void CDUCCCircuit::FlashShape(long shape, short times)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x161, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, times);
}

long CDUCCCircuit::GetMaxUndoActionCount()
{
	long result;
	InvokeHelper(0x162, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetMaxRedoActionCount()
{
	long result;
	InvokeHelper(0x163, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetMaxUndoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCCircuit::SetMaxRedoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x165, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCCircuit::ChangeRulerUnit(short unit)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x166, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		unit);
}

void CDUCCCircuit::SelectShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x167, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCCircuit::GetBackgroundShapeCount()
{
	long result;
	InvokeHelper(0x168, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetBackShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x169, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCCircuit::AddShapeToBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCCircuit::RemoveShapeFromBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCCircuit::RemoveAllShapesFromBack()
{
	InvokeHelper(0x16c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::FindShapeWithNameFromBack(LPCTSTR Name)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x16d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		Name);
	return result;
}

long CDUCCCircuit::CloneShape(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::RemoveAllPorts(long portsshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		portsshape);
}

long CDUCCCircuit::GetShapePointCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x170, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetShapePointXAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x171, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

long CDUCCCircuit::GetShapePointYAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x172, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

void CDUCCCircuit::AddShapePoint(long shape, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x173, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, x, y);
}

void CDUCCCircuit::RemoveShapePoint(long shape, long index)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x174, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index);
}

void CDUCCCircuit::InsertShapePoint(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x175, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

void CDUCCCircuit::SetShapePointAt(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x176, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

BOOL CDUCCCircuit::IsToolBoxVisible()
{
	BOOL result;
	InvokeHelper(0x177, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::ShowToolBoxWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x178, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::RomoveToolBoxPage(long index)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x179, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		index);
}

long CDUCCCircuit::GetToolBoxPageCount()
{
	long result;
	InvokeHelper(0x17a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableToolboxEditProp(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x17b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCCircuit::FODPtoLPX(long xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCCircuit::FODPtoLPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

long CDUCCCircuit::FOLPtoDPX(short xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x17e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCCircuit::FOLPtoDPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

void CDUCCCircuit::EnableUniqueCaption(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x180, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCCircuit::EnableUniqueName(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x181, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCCircuit::GetPortParentShape(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x182, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCCircuit::CreateShape(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x183, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

void CDUCCCircuit::AddListField(long listshape, short index, BOOL bshowleftport, BOOL bshowrightport, LPCTSTR strfield)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL VTS_BOOL VTS_BSTR;
	InvokeHelper(0x184, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		listshape, index, bshowleftport, bshowrightport, strfield);
}

void CDUCCCircuit::UpdateShapeGeo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x185, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCCircuit::FindPortFromIndex(long listshape, short index, BOOL bLeftPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL;
	InvokeHelper(0x186, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape, index, bLeftPort);
	return result;
}

long CDUCCCircuit::LinkTwoField(long FromPort, long ToPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x187, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromPort, ToPort);
	return result;
}

long CDUCCCircuit::GetFieldCountOfListCtrl(long listshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x188, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape);
	return result;
}

CString CDUCCCircuit::GetFieldCaption(long listshape, short index)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x189, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		listshape, index);
	return result;
}

void CDUCCCircuit::DoDrawImageNode(LPDISPATCH iPictureDisp)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x18a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		iPictureDisp);
}

long CDUCCCircuit::AddImageNode(short x, short y, LPDISPATCH iPictureDisp)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_DISPATCH;
	InvokeHelper(0x18b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		x, y, iPictureDisp);
	return result;
}

void CDUCCCircuit::EnableContinueDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x18c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCCircuit::DoMakeSubgraph()
{
	InvokeHelper(0x18d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UnGroupSubgraph()
{
	InvokeHelper(0x18e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoVCPrintPreview()
{
	InvokeHelper(0x18f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ChangeToolBoxBackColor(long crFirst, long crLast)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x190, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crFirst, crLast);
}

BOOL CDUCCCircuit::GetModelBoolProp(long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x191, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		nPropID);
	return result;
}

CString CDUCCCircuit::GetModelStringProp(long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x192, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCCircuit::GetModelIntProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x193, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

float CDUCCCircuit::GetModelFloatProp(long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x194, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		nPropID);
	return result;
}

double CDUCCCircuit::GetModelDoubleProp(long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x195, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		nPropID);
	return result;
}

DATE CDUCCCircuit::GetModelDateTimeProp(long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x196, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCCircuit::GetModelColorProp(float nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_R4;
	InvokeHelper(0x197, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCCircuit::GetModelDWordProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x198, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

void CDUCCCircuit::DoDrawEllipse2()
{
	InvokeHelper(0x199, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::AddEllipse2Shape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x19a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

void CDUCCCircuit::DoDrawNewBizerLine()
{
	InvokeHelper(0x19b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::EnterEditingBack()
{
	InvokeHelper(0x19c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::EndEditingBack()
{
	InvokeHelper(0x19d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCCircuit::IsModified()
{
	BOOL result;
	InvokeHelper(0x19e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoAutoReroute()
{
	InvokeHelper(0x19f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::AddSimplePathShape(long xStart, long yStart, long xEnd, long yEnd, short nType)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1a0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nType);
	return result;
}

void CDUCCCircuit::EnableFreeFormDrawing(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsFreeFormDrawing()
{
	BOOL result;
	InvokeHelper(0x1a2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsEnableSnapDynGrid()
{
	BOOL result;
	InvokeHelper(0x1a3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::EnableSnapDynGrid(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCCircuit::EnableSnapAidLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsEnableSnapAidLine()
{
	BOOL result;
	InvokeHelper(0x1a6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::ShowColorThemeDlg()
{
	InvokeHelper(0x1a7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawCurveLink()
{
	InvokeHelper(0x1a8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoDrawRoundCornerLinkLine()
{
	InvokeHelper(0x1a9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::MoveShapeTo(long shape, long xPos, long yPos)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1aa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xPos, yPos);
}

void CDUCCCircuit::SetShapeDimension(long shape, long Width, long Height)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, Width, Height);
}

BOOL CDUCCCircuit::GetShapeShowLabelAtFirst(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ac, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetShapeShowLabelAtFirst(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1ad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCCircuit::GetShapeWithLabelShow(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ae, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetShapeWithLabelShow(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1af, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCCircuit::GetShapeWithLabelEditing(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1b0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetShapeWithLabelEditing(long shape, BOOL bEnable)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1b1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bEnable);
}

void CDUCCCircuit::MPreparePtAry()
{
	InvokeHelper(0x1b2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::MAddPtToAry(long xPoint, long yPoint)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1b3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xPoint, yPoint);
}

long CDUCCCircuit::AddPolylineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCCircuit::MAddPolygonShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCCircuit::MAddBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCCircuit::MAddCloseBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCCircuit::MAddExtBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

void CDUCCCircuit::MAddLinkShape(short nLinkType, long FromPort, long ToPort, short arrowtype)
{
	static BYTE parms[] =
		VTS_I2 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1b9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, FromPort, ToPort, arrowtype);
}

long CDUCCCircuit::GetShapeCenterPort(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ba, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetApplicationName(LPCTSTR pszAppName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1bb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		pszAppName);
}

BOOL CDUCCCircuit::FindShapeWithinDataModel(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1bc, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCCircuit::AddBoolUserProperty(long shape, long nPropID, BOOL bValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1bd, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, bValue);
	return result;
}

BOOL CDUCCCircuit::AddStringUserProperty(long shape, long nPropID, LPCTSTR strValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1be, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, strValue);
	return result;
}

BOOL CDUCCCircuit::AddIntUserProperty(long shape, long nPropID, long nValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1bf, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, nValue);
	return result;
}

BOOL CDUCCCircuit::AddFloatUserProperty(long shape, long nPropID, float fValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, fValue);
	return result;
}

BOOL CDUCCCircuit::AddDoubleUserProperty(long shape, long nPropID, double dValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c1, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dValue);
	return result;
}

BOOL CDUCCCircuit::AddDateUserProperty(long shape, long nPropID, DATE dtTime)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1c2, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dtTime);
	return result;
}

BOOL CDUCCCircuit::AddColorUserProperty(long shape, long nPropID, long crColor)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c3, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, crColor);
	return result;
}

BOOL CDUCCCircuit::AddDWordUserProperty(long shape, long nPropID, long dwData)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dwData);
	return result;
}

void CDUCCCircuit::ChangeShapeBoolWithoutUndo(long shape, long nPropID, BOOL bValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1c5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, bValue);
}

void CDUCCCircuit::ChangeShapeStringWithoutUndo(long shape, long nPropID, LPCTSTR strValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1c6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, strValue);
}

void CDUCCCircuit::ChangeShapeIntWithoutUndo(long shape, long nPropID, long nValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, nValue);
}

void CDUCCCircuit::ChangeShapeFloatWithoutUndo(long shape, long nPropID, float fValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, fValue);
}

void CDUCCCircuit::ChangeShapeDoubleWithoutUndo(long shape, long nPropID, double dValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dValue);
}

void CDUCCCircuit::ChangeShapeDWordWithoutUndo(long shape, long nPropID, long dwValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ca, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dwValue);
}

void CDUCCCircuit::ChangeShapeColorWithoutUndo(long shape, long nPropID, long crColor)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1cb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, crColor);
}

void CDUCCCircuit::ChangeShapeDateWithoutUndo(long shape, long nPropID, DATE dtValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1cc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dtValue);
}

long CDUCCCircuit::GetLinkCount()
{
	long result;
	InvokeHelper(0x1cd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetLinkAt(long nIndex)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ce, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nIndex);
	return result;
}

long CDUCCCircuit::GetSelectedLinkCount()
{
	long result;
	InvokeHelper(0x1cf, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetSelectedLinkAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCCircuit::RemoveShapeWithoutUndo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCCircuit::GetShapeLinksCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetShapeLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetShapeFromLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetShapeFromLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetShapeToLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetShapeToLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetDirectLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetDirectLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetDirectLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1da, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetDirectLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1db, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetDirectLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1dc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetDirectLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1dd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetAllLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1de, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetAllLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1df, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetAllLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetAllLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetAllLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCCircuit::GetAllLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCCircuit::GetFocusShape()
{
	long result;
	InvokeHelper(0x1e4, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::AddLinkShapeNoUndo(long FromNode, long ToNode, short LinkType, short arrowtype)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromNode, ToNode, LinkType, arrowtype);
	return result;
}

void CDUCCCircuit::ChangeToolBoxIndexFile(LPCTSTR strNewFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1e6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strNewFile);
}

void CDUCCCircuit::DoShowProtDlg()
{
	InvokeHelper(0x1e7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::SaveToImage()
{
	long result;
	InvokeHelper(0x1e8, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::LoadFromImage(long hEmf, short xStart, short yStart)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		hEmf, xStart, yStart);
	return result;
}

void CDUCCCircuit::EndTextBoxEdit()
{
	InvokeHelper(0x1ea, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::EndEditBoxEdit()
{
	InvokeHelper(0x1eb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::EndComboBoxEdit()
{
	InvokeHelper(0x1ec, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::StartRichTextEdit(long richshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ed, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		richshape);
}

long CDUCCCircuit::SaveMemory(long* xlen)
{
	long result;
	static BYTE parms[] =
		VTS_PI4;
	InvokeHelper(0x1ee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xlen);
	return result;
}

void CDUCCCircuit::LoadMemory(long hMem, long* xlen)
{
	static BYTE parms[] =
		VTS_I4 VTS_PI4;
	InvokeHelper(0x1ef, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		hMem, xlen);
}

BOOL CDUCCCircuit::SaveMemory2(LPCTSTR filename, long pData, long nSize)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4 VTS_I4;
	InvokeHelper(0x1f0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		filename, pData, nSize);
	return result;
}

long CDUCCCircuit::LoadMemory2(LPCTSTR filename, long lpData)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x1f1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		filename, lpData);
	return result;
}

void CDUCCCircuit::InsertOleShape()
{
	InvokeHelper(0x1f2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ShowOpenFileDialog()
{
	InvokeHelper(0x1f3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ShowSaveFileDialog()
{
	InvokeHelper(0x1f4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ShowTemplateOpenDialog()
{
	InvokeHelper(0x1f5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ShowSaveTemplateDialog()
{
	InvokeHelper(0x1f6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::ShowOptionDialog()
{
	InvokeHelper(0x1f7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::UpdateAllWindows()
{
	InvokeHelper(0x1f8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::DoSetDBName()
{
	InvokeHelper(0x1f9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCCircuit::AddBoxShape(long xPos, long yPos, long szWidth, long szHeight, LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPos, yPos, szWidth, szHeight, strCaption);
	return result;
}

long CDUCCCircuit::GetShapeType(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

CString CDUCCCircuit::GetCurrentText(long shape)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fc, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetCurrentText(long shape, LPCTSTR sText)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fd, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, sText);
}

BOOL CDUCCCircuit::IsEFormShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fe, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetEFormFocusShape()
{
	long result;
	InvokeHelper(0x1ff, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SetPointLimitWithPage(BOOL bWithIn)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x200, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bWithIn);
}

void CDUCCCircuit::ShowBarCodeLabel(long barcodeshape, BOOL bVisible)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x201, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		barcodeshape, bVisible);
}

void CDUCCCircuit::UpdateControl(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x202, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCCircuit::GetRunTimeInputText()
{
	InvokeHelper(0x203, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::SetFocusOnShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x204, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCCircuit::LoadXdgFromFile(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x205, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCCircuit::SaveToXdgFile(LPCTSTR lpszFileName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x206, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszFileName);
}

long CDUCCCircuit::FindShapeWithKey1(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x207, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCCircuit::FindShapeWithKey2(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x208, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCCircuit::FindShapeWithKey3(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x209, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCCircuit::FindShapeWithKeyInComp1(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCCircuit::FindShapeWithKeyInComp2(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCCircuit::FindShapeWithKeyInComp3(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

void CDUCCCircuit::RotateFromCenter(long shape, short angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x20d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCCircuit::MoveCenterTo(long shape, long xNew, long yNew)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x20e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xNew, yNew);
}

void CDUCCCircuit::ScaleFromCenter(long shape, double dX, double dY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x20f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dX, dY);
}

void CDUCCCircuit::InitLinkTypeAndArrow(short nLinkType, short nArrowType)
{
	static BYTE parms[] =
		VTS_I2 VTS_I2;
	InvokeHelper(0x210, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, nArrowType);
}

long CDUCCCircuit::AddShapeWithoutUndo(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x211, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCCircuit::GetCanvasWidth2()
{
	long result;
	InvokeHelper(0x212, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetCanvasHeight2()
{
	long result;
	InvokeHelper(0x213, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::ShowPortPinName(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x214, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::RemoveAllFromSelection(BOOL bRedraw)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x215, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bRedraw);
}

BOOL CDUCCCircuit::DoBendFree()
{
	BOOL result;
	InvokeHelper(0x216, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsAllowBendFree()
{
	BOOL result;
	InvokeHelper(0x217, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::SelectNewShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x218, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCCircuit::ShowPanWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x219, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowFileBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowDrawBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowFontBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowFormartBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowAlignBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowStatusBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowLinkBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x220, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::ShowOperatorBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x221, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCCircuit::SetAllowHoleLink(short bEnable)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x222, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCCircuit::IsPanWindowVisible()
{
	BOOL result;
	InvokeHelper(0x223, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsFileBarVisible()
{
	BOOL result;
	InvokeHelper(0x224, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsDrawBarVisible()
{
	BOOL result;
	InvokeHelper(0x225, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsFontBarVisible()
{
	BOOL result;
	InvokeHelper(0x226, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsFormatBarVisible()
{
	BOOL result;
	InvokeHelper(0x227, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsAlignBarVisible()
{
	BOOL result;
	InvokeHelper(0x228, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsLinkBarVisible()
{
	BOOL result;
	InvokeHelper(0x229, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsOptBarVisible()
{
	BOOL result;
	InvokeHelper(0x22a, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCCircuit::IsStatusBarVisible()
{
	BOOL result;
	InvokeHelper(0x22b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCCircuit::DoShowKeyDlg()
{
	InvokeHelper(0x22c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

double CDUCCCircuit::ConvertToMapLog(double dConvertValue, short dUnit, BOOL bVert)
{
	double result;
	static BYTE parms[] =
		VTS_R8 VTS_I2 VTS_BOOL;
	InvokeHelper(0x22d, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		dConvertValue, dUnit, bVert);
	return result;
}

void CDUCCCircuit::OnNewFile()
{
	InvokeHelper(0x22e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::SetCanvasSize(long szWidthPt, long szHeightPt)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x22f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		szWidthPt, szHeightPt);
}

double CDUCCCircuit::GetGaugeCurrentValue(long gaugeshape)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x230, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		gaugeshape);
	return result;
}

void CDUCCCircuit::SetGaugeCurrentValue(long gaugeshape, double newvalue)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8;
	InvokeHelper(0x231, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		gaugeshape, newvalue);
}

BOOL CDUCCCircuit::SaveTemplateToFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x232, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

BOOL CDUCCCircuit::LoadTemplateFromFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x233, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

double CDUCCCircuit::GetZoomXScale()
{
	double result;
	InvokeHelper(0x234, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCCircuit::GetZoomYScale()
{
	double result;
	InvokeHelper(0x235, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCCircuit::GetUIScale()
{
	double result;
	InvokeHelper(0x236, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetUIUnit()
{
	long result;
	InvokeHelper(0x237, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCCircuit::GetShapeID(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x238, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCCircuit::SetShapeID(long shape, long nId)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x239, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nId);
}

long CDUCCCircuit::FindShapeByID(long nId)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nId);
	return result;
}

long CDUCCCircuit::NewConnectTwoShapes(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x23b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey);
	return result;
}

long CDUCCCircuit::ConnectShapeWithPorts(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey, short nLinkStyle)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I2;
	InvokeHelper(0x23c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey, nLinkStyle);
	return result;
}

CXDShape CDUCCCircuit::Convert(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23d, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDShape(pDispatch);
}

void CDUCCCircuit::LockUpdate(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

BOOL CDUCCCircuit::IsLockUpdate()
{
	BOOL result;
	InvokeHelper(0x23f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

CXDGroupShape CDUCCCircuit::ConvertToGroup(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x240, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDGroupShape(pDispatch);
}

CXDLinkShape CDUCCCircuit::ConvertToLink(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x241, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDLinkShape(pDispatch);
}

CXDPortsShape CDUCCCircuit::ConvertToPortsShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x242, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortsShape(pDispatch);
}

CXDPortShape CDUCCCircuit::ConvertToPortShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x243, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortShape(pDispatch);
}

CXDEFormShape CDUCCCircuit::ConvertToEFormShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x244, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDEFormShape(pDispatch);
}

void CDUCCCircuit::UpdateFullWindows()
{
	InvokeHelper(0x245, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::HideAllToolBars()
{
	InvokeHelper(0x246, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::HideCanvasBorder()
{
	InvokeHelper(0x247, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCCircuit::HideAllScrollBars()
{
	InvokeHelper(0x248, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}
